import * as peekView from "vscode/vscode/vs/editor/contrib/peekView/browser/peekView";
import { ICodeEditor } from "vscode/vscode/vs/editor/browser/editorBrowser";
import { IInstantiationService } from "vscode/vscode/vs/platform/instantiation/common/instantiation";
import { CallHierarchyDirection, CallHierarchyModel } from "@codingame/monaco-vscode-7f39b6f1-3542-5430-8760-0f404d7a7cee-common/vscode/vs/workbench/contrib/callHierarchy/common/callHierarchy";
import * as callHTree from "./callHierarchyTree.js";
import { IEditorService } from "vscode/vscode/vs/workbench/services/editor/common/editorService.service";
import { ITextModelService } from "vscode/vscode/vs/editor/common/services/resolverService";
import { IThemeService } from "vscode/vscode/vs/platform/theme/common/themeService.service";
import { IPosition } from "vscode/vscode/vs/editor/common/core/position";
import { IStorageService } from "vscode/vscode/vs/platform/storage/common/storage.service";
import { MenuId } from "vscode/vscode/vs/platform/actions/common/actions";
import { IMenuService } from "vscode/vscode/vs/platform/actions/common/actions.service";
import { IContextKeyService } from "vscode/vscode/vs/platform/contextkey/common/contextkey.service";
export declare class CallHierarchyTreePeekWidget extends peekView.PeekViewWidget {
    private readonly _where;
    private _direction;
    private readonly _peekViewService;
    private readonly _editorService;
    private readonly _textModelService;
    private readonly _storageService;
    private readonly _menuService;
    private readonly _contextKeyService;
    private readonly _instantiationService;
    static readonly TitleMenu: MenuId;
    private _parent;
    private _message;
    private _splitView;
    private _tree;
    private _treeViewStates;
    private _editor;
    private _dim;
    private _layoutInfo;
    private readonly _previewDisposable;
    constructor(editor: ICodeEditor, _where: IPosition, _direction: CallHierarchyDirection, themeService: IThemeService, _peekViewService: peekView.IPeekViewService, _editorService: IEditorService, _textModelService: ITextModelService, _storageService: IStorageService, _menuService: IMenuService, _contextKeyService: IContextKeyService, _instantiationService: IInstantiationService);
    dispose(): void;
    get direction(): CallHierarchyDirection;
    private _applyTheme;
    protected _fillHead(container: HTMLElement): void;
    protected _fillBody(parent: HTMLElement): void;
    private _updatePreview;
    showLoading(): void;
    showMessage(message: string): void;
    showModel(model: CallHierarchyModel): Promise<void>;
    getModel(): CallHierarchyModel | undefined;
    getFocused(): callHTree.Call | undefined;
    updateDirection(newDirection: CallHierarchyDirection): Promise<void>;
    private _show;
    protected _onWidth(width: number): void;
    protected _doLayoutBody(height: number, width: number): void;
}
