import { Event } from "vscode/vscode/vs/base/common/event";
import { Disposable, IDisposable } from "vscode/vscode/vs/base/common/lifecycle";
import { URI } from "vscode/vscode/vs/base/common/uri";
import { IFileService } from "vscode/vscode/vs/platform/files/common/files.service";
import { IInstantiationService } from "vscode/vscode/vs/platform/instantiation/common/instantiation";
import { IStorageService } from "vscode/vscode/vs/platform/storage/common/storage.service";
import { IUriIdentityService } from "vscode/vscode/vs/platform/uriIdentity/common/uriIdentity.service";
import { CustomEditorCapabilities, CustomEditorInfo, CustomEditorInfoCollection } from "../common/customEditor.js";
import { ICustomEditorService } from "vscode/vscode/vs/workbench/contrib/customEditor/common/customEditor.service";
import { CustomEditorModelManager } from "../common/customEditorModelManager.js";
import { IEditorGroupsService } from "vscode/vscode/vs/workbench/services/editor/common/editorGroupsService.service";
import { IEditorType } from "vscode/vscode/vs/workbench/services/editor/common/editorResolverService";
import { IEditorResolverService } from "vscode/vscode/vs/workbench/services/editor/common/editorResolverService.service";
import { IEditorService } from "vscode/vscode/vs/workbench/services/editor/common/editorService.service";
export declare class CustomEditorService extends Disposable implements ICustomEditorService {
    private readonly editorService;
    private readonly editorGroupService;
    private readonly instantiationService;
    private readonly uriIdentityService;
    private readonly editorResolverService;
    _serviceBrand: any;
    private readonly _contributedEditors;
    private _untitledCounter;
    private readonly _editorResolverDisposables;
    private readonly _editorCapabilities;
    private readonly _models;
    private readonly _onDidChangeEditorTypes;
    readonly onDidChangeEditorTypes: Event<void>;
    private readonly _fileEditorFactory;
    constructor(fileService: IFileService, storageService: IStorageService, editorService: IEditorService, editorGroupService: IEditorGroupsService, instantiationService: IInstantiationService, uriIdentityService: IUriIdentityService, editorResolverService: IEditorResolverService);
    getEditorTypes(): IEditorType[];
    private withActiveCustomEditor;
    private registerContributionPoints;
    private createDiffEditorInput;
    get models(): CustomEditorModelManager;
    getCustomEditor(viewType: string): CustomEditorInfo | undefined;
    getContributedCustomEditors(resource: URI): CustomEditorInfoCollection;
    getUserConfiguredCustomEditors(resource: URI): CustomEditorInfoCollection;
    getAllCustomEditors(resource: URI): CustomEditorInfoCollection;
    registerCustomEditorCapabilities(viewType: string, options: CustomEditorCapabilities): IDisposable;
    getCustomEditorCapabilities(viewType: string): CustomEditorCapabilities | undefined;
    private getActiveCustomEditorId;
    private getCustomEditorIsEditable;
    private handleMovedFileInOpenedFileEditors;
}
