import { Disposable } from "vscode/vscode/vs/base/common/lifecycle";
import { IObservable, ITransaction } from "vscode/vscode/vs/base/common/observable";
import { Range } from "vscode/vscode/vs/editor/common/core/range";
import { IConfigurationService } from "vscode/vscode/vs/platform/configuration/common/configuration.service";
import { INotificationService } from "vscode/vscode/vs/platform/notification/common/notification.service";
import { MergeEditorModel } from "@codingame/monaco-vscode-8ccb7637-50ea-5359-97bf-00015d7fe567-common/vscode/vs/workbench/contrib/mergeEditor/browser/model/mergeEditorModel";
import { InputNumber, ModifiedBaseRange, ModifiedBaseRangeState } from "@codingame/monaco-vscode-464d4abe-0937-5367-af84-1b9279e14ea3-common/vscode/vs/workbench/contrib/mergeEditor/browser/model/modifiedBaseRange";
import { BaseCodeEditorView } from "./editors/baseCodeEditorView.js";
import { CodeEditorView } from "./editors/codeEditorView.js";
import { InputCodeEditorView } from "./editors/inputCodeEditorView.js";
import { ResultCodeEditorView } from "./editors/resultCodeEditorView.js";
export declare class MergeEditorViewModel extends Disposable {
    readonly model: MergeEditorModel;
    readonly inputCodeEditorView1: InputCodeEditorView;
    readonly inputCodeEditorView2: InputCodeEditorView;
    readonly resultCodeEditorView: ResultCodeEditorView;
    readonly baseCodeEditorView: IObservable<BaseCodeEditorView | undefined>;
    readonly showNonConflictingChanges: IObservable<boolean>;
    private readonly configurationService;
    private readonly notificationService;
    private readonly manuallySetActiveModifiedBaseRange;
    private readonly attachedHistory;
    constructor(model: MergeEditorModel, inputCodeEditorView1: InputCodeEditorView, inputCodeEditorView2: InputCodeEditorView, resultCodeEditorView: ResultCodeEditorView, baseCodeEditorView: IObservable<BaseCodeEditorView | undefined>, showNonConflictingChanges: IObservable<boolean>, configurationService: IConfigurationService, notificationService: INotificationService);
    readonly shouldUseAppendInsteadOfAccept: IObservable<boolean, unknown>;
    private counter;
    private readonly lastFocusedEditor;
    readonly baseShowDiffAgainst: IObservable<2 | 1 | undefined, unknown>;
    readonly selectionInBase: IObservable<{
        rangesInBase: Range[];
        sourceEditor: CodeEditorView;
    } | undefined, unknown>;
    private getRangeOfModifiedBaseRange;
    readonly activeModifiedBaseRange: IObservable<ModifiedBaseRange | undefined, unknown>;
    setActiveModifiedBaseRange(range: ModifiedBaseRange | undefined, tx: ITransaction): void;
    setState(baseRange: ModifiedBaseRange, state: ModifiedBaseRangeState, tx: ITransaction, inputNumber: InputNumber): void;
    private goToConflict;
    goToNextModifiedBaseRange(predicate: (m: ModifiedBaseRange) => boolean): void;
    goToPreviousModifiedBaseRange(predicate: (m: ModifiedBaseRange) => boolean): void;
    toggleActiveConflict(inputNumber: 1 | 2): void;
    acceptAll(inputNumber: 1 | 2): void;
}
