import { Disposable } from "vscode/vscode/vs/base/common/lifecycle";
import { IConfigurationService } from "vscode/vscode/vs/platform/configuration/common/configuration.service";
import { IWorkbenchColorTheme } from "@codingame/monaco-vscode-9d0168a3-519b-57f3-9bcc-89efc41f951a-common/vscode/vs/workbench/services/themes/common/workbenchThemeService";
import { IWorkbenchThemeService } from "@codingame/monaco-vscode-3dd5b442-bfbc-5b1d-8f4a-7567530c75f5-common/vscode/vs/workbench/services/themes/common/workbenchThemeService.service";
import { WebviewStyles } from "@codingame/monaco-vscode-22790577-4553-50b6-978d-0acc75c394cc-common/vscode/vs/workbench/contrib/webview/browser/webview";
interface WebviewThemeData {
    readonly activeTheme: string;
    readonly themeLabel: string;
    readonly themeId: string;
    readonly styles: Readonly<WebviewStyles>;
}
export declare class WebviewThemeDataProvider extends Disposable {
    private readonly _themeService;
    private readonly _configurationService;
    private _cachedWebViewThemeData;
    private readonly _onThemeDataChanged;
    readonly onThemeDataChanged: import("vscode/vscode/vs/base/common/event").Event<void>;
    constructor(_themeService: IWorkbenchThemeService, _configurationService: IConfigurationService);
    getTheme(): IWorkbenchColorTheme;
    getWebviewThemeData(): WebviewThemeData;
    private _reset;
}
export {};
