import { IConfigurationService } from "vscode/vscode/vs/platform/configuration/common/configuration.service";
import { IContextKeyService } from "vscode/vscode/vs/platform/contextkey/common/contextkey.service";
import { IContextMenuService } from "vscode/vscode/vs/platform/contextview/browser/contextView.service";
import { IInstantiationService } from "vscode/vscode/vs/platform/instantiation/common/instantiation";
import { IKeybindingService } from "vscode/vscode/vs/platform/keybinding/common/keybinding.service";
import { IOpenerService } from "vscode/vscode/vs/platform/opener/common/opener.service";
import { IProgressService } from "vscode/vscode/vs/platform/progress/common/progress.service";
import { IStorageService } from "vscode/vscode/vs/platform/storage/common/storage.service";
import { ITelemetryService } from "vscode/vscode/vs/platform/telemetry/common/telemetry.service";
import { IThemeService } from "vscode/vscode/vs/platform/theme/common/themeService.service";
import { ViewPane } from "@codingame/monaco-vscode-65619f8f-0eab-5d8b-855a-43b6353fe527-common/vscode/vs/workbench/browser/parts/views/viewPane";
import { IViewletViewOptions } from "@codingame/monaco-vscode-2a94c04a-b85b-5669-b06b-89c1bfa11cb9-common/vscode/vs/workbench/browser/parts/views/viewsViewlet";
import { IViewBadge } from "vscode/vscode/vs/workbench/common/views";
import { IViewDescriptorService } from "vscode/vscode/vs/workbench/common/views.service";
import { IViewsService } from "vscode/vscode/vs/workbench/services/views/common/viewsService.service";
import { IWebviewService } from "vscode/vscode/vs/workbench/contrib/webview/browser/webview.service";
import { IWebviewViewService } from "vscode/vscode/vs/workbench/contrib/webviewView/browser/webviewViewService.service";
import { IActivityService } from "vscode/vscode/vs/workbench/services/activity/common/activity.service";
import { IExtensionService } from "vscode/vscode/vs/workbench/services/extensions/common/extensions.service";
import { IHoverService } from "vscode/vscode/vs/platform/hover/browser/hover.service";
export declare class WebviewViewPane extends ViewPane {
    private readonly activityService;
    private readonly extensionService;
    private readonly progressService;
    private readonly storageService;
    private readonly viewService;
    private readonly webviewService;
    private readonly webviewViewService;
    private static _originStore?;
    private static getOriginStore;
    private readonly _webview;
    private readonly _webviewDisposables;
    private _activated;
    private _container?;
    private _rootContainer?;
    private _resizeObserver?;
    private readonly defaultTitle;
    private setTitle;
    private badge;
    private readonly activity;
    private readonly memento;
    private readonly viewState;
    private readonly extensionId?;
    private _repositionTimeout?;
    constructor(options: IViewletViewOptions, configurationService: IConfigurationService, contextKeyService: IContextKeyService, contextMenuService: IContextMenuService, instantiationService: IInstantiationService, keybindingService: IKeybindingService, openerService: IOpenerService, telemetryService: ITelemetryService, hoverService: IHoverService, themeService: IThemeService, viewDescriptorService: IViewDescriptorService, activityService: IActivityService, extensionService: IExtensionService, progressService: IProgressService, storageService: IStorageService, viewService: IViewsService, webviewService: IWebviewService, webviewViewService: IWebviewViewService);
    private readonly _onDidChangeVisibility;
    readonly onDidChangeVisibility: import("vscode/vscode/vs/base/common/event").Event<boolean>;
    private readonly _onDispose;
    readonly onDispose: import("vscode/vscode/vs/base/common/event").Event<void>;
    dispose(): void;
    focus(): void;
    protected renderBody(container: HTMLElement): void;
    saveState(): void;
    protected layoutBody(height: number, width: number): void;
    private updateTreeVisibility;
    private activate;
    protected updateTitle(value: string | undefined): void;
    protected updateBadge(badge: IViewBadge | undefined): void;
    private withProgress;
    onDidScrollRoot(): void;
    private doLayoutWebview;
    private layoutWebview;
    private findRootContainer;
}
