import { Disposable } from "vscode/vscode/vs/base/common/lifecycle";
import { IProgressOptions, IProgressStep, IProgress } from "vscode/vscode/vs/platform/progress/common/progress";
import { IProgressService } from "vscode/vscode/vs/platform/progress/common/progress.service";
import { IStatusbarService } from "vscode/vscode/vs/workbench/services/statusbar/browser/statusbar.service";
import { IActivityService } from "vscode/vscode/vs/workbench/services/activity/common/activity.service";
import { INotificationService } from "vscode/vscode/vs/platform/notification/common/notification.service";
import { ILayoutService } from "vscode/vscode/vs/platform/layout/browser/layoutService.service";
import { IKeybindingService } from "vscode/vscode/vs/platform/keybinding/common/keybinding.service";
import { IViewDescriptorService } from "vscode/vscode/vs/workbench/common/views.service";
import { IViewsService } from "vscode/vscode/vs/workbench/services/views/common/viewsService.service";
import { IPaneCompositePartService } from "vscode/vscode/vs/workbench/services/panecomposite/browser/panecomposite.service";
import { IUserActivityService } from "vscode/vscode/vs/workbench/services/userActivity/common/userActivityService.service";
export declare class ProgressService extends Disposable implements IProgressService {
    private readonly activityService;
    private readonly paneCompositeService;
    private readonly viewDescriptorService;
    private readonly viewsService;
    private readonly notificationService;
    private readonly statusbarService;
    private readonly layoutService;
    private readonly keybindingService;
    private readonly userActivityService;
    readonly _serviceBrand: undefined;
    constructor(activityService: IActivityService, paneCompositeService: IPaneCompositePartService, viewDescriptorService: IViewDescriptorService, viewsService: IViewsService, notificationService: INotificationService, statusbarService: IStatusbarService, layoutService: ILayoutService, keybindingService: IKeybindingService, userActivityService: IUserActivityService);
    withProgress<R = unknown>(options: IProgressOptions, originalTask: (progress: IProgress<IProgressStep>) => Promise<R>, onDidCancel?: (choice?: number) => void): Promise<R>;
    private readonly windowProgressStack;
    private windowProgressStatusEntry;
    private withWindowProgress;
    private updateWindowProgress;
    private withNotificationProgress;
    private withPaneCompositeProgress;
    private withViewProgress;
    private showOnActivityBar;
    private withCompositeProgress;
    private withDialogProgress;
}
